#ifndef __AtmelAT91SPI_H
#define __AtmelAT91SPI_H
#include "SPI.h"
#include "Bus.h"
#include "Pin.h"
#include "DIO.h"

typedef struct AtmelAT91SPI AtmelAT91SPI;
struct AtmelAT91SPI {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  // "adrs" parameter indicates which CS to assert
  // if adrs < 0, then -adrs is used, and CS left asserted when done
  // otherwise, CS is de-asserted with last transfer
  int FUNC(Write)(void *me,int adrs,unsigned char *buf,int len);
  int FUNC(Read)(void *me,int adrs,unsigned char *buf,int len);
  int FUNC(ReadWrite)(void *me,int adrs,unsigned char *wbuf,unsigned char *rbuf, int len);
  int FUNC(ClockSet)(void *me,unsigned hz);
  int FUNC(EdgeSet)(void *me,int posedge);
  int InitStatus;
  Bus *bus;
  unsigned LockNum;
  Pin *pin;
  DIO *dio1,*dio2,*dio3;
  int cs1,cs2,cs3;
};

void *AtmelAT91SPIInit(AtmelAT91SPI *,void *bus,void *pin,
		       DIO *dio1,int cs1,DIO *dio2,int cs2,DIO *dio3,int cs3);
void AtmelAT91SPIFini(AtmelAT91SPI *);
int AtmelAT91SPILock(AtmelAT91SPI *spi,unsigned num,int flags);
int AtmelAT91SPIUnlock(AtmelAT91SPI *spi,unsigned num,int flags);
void AtmelAT91SPIPreempt(AtmelAT91SPI *spi);
int AtmelAT91SPIWrite(AtmelAT91SPI *ob,int adrs,char *buf,int len);
int AtmelAT91SPIRead(AtmelAT91SPI *ob,int adrs,char *buf,int len);
int AtmelAT91SPIReadWrite(AtmelAT91SPI *ob,int adrs,unsigned char *wbuf,unsigned char *rbuf, int len);
int AtmelAT91SPIClockSet(AtmelAT91SPI *ob,unsigned hz);
int AtmelAT91SPIEdgeSet(AtmelAT91SPI *ob,int posedge);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
