#ifndef __DummyDIO_H
#define __DummyDIO_H
#include "DIO.h"
#include "Bus.h"
#include "DIORaw.h"
#include "Pin.h"

typedef struct DummyDIO DummyDIO;

struct DummyDIO {
  void *FUNC(Init)(void *me);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  void FUNC(Refresh)(void *me);
  void FUNC(Commit)(void *me,int forceall);
  void FUNC(Set)(void *me,int DIONum,DIOState State);
  DIOState FUNC(Get)(void *me,int DIONum);
  void FUNC(SetAsync)(void *me,int DIONum,DIOState State);
  DIOState FUNC(GetAsync)(void *me,int DIONum);
  int FUNC(Wait)(void *me,int *match,int min,int max,int nh,int *h,int nl,int *l);
  unsigned FUNC(Count)(void *me);
  DIOCaps FUNC(Capabilities)(void *me,unsigned num);
  //void FUNC(ToggleAsync)(void *me,int DIONum);
  //void FUNC(Toggle)(void *me,int DIONum);
  int InitStatus;
  unsigned NumLocks;
};

void *DummyDIOInit(DummyDIO *,int count);
void DummyDIOFini(DummyDIO *);
int DummyDIOLock(DummyDIO *dio,unsigned num,int flags);
int DummyDIOUnlock(DummyDIO *dio,unsigned num,int flags);
void DummyDIOPreempt(DummyDIO *dio);
void DummyDIORefresh(DummyDIO *);
void DummyDIOCommit(DummyDIO *,int forceall);
void DummyDIOSet(DummyDIO *,int DIONum,DIOState State);
DIOState DummyDIOGet(DummyDIO *,int DIONum);
void DummyDIOSetAsync(DummyDIO *,int DIONum,DIOState State);
DIOState DummyDIOGetAsync(DummyDIO *,int DIONum);
int DummyDIOWait(DummyDIO *,int *match,int min,int max,int nh,
		    int *h,int nl,int *l);
unsigned DummyDIOCount(DummyDIO *);
DIOCaps DummyDIOCapabilities(DummyDIO *,unsigned num);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
