#ifndef __LinuxTWI_H
#define __LinuxTWI_H
#include "TWI.h"
#include "Bus.h"

typedef struct LinuxTWI LinuxTWI;
struct LinuxTWI {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  int FUNC(Write)(void *me,int devadr,int adrslen,int adrs,int len,char *bytes);
  int FUNC(Read)(void *me,int devadr,int adrslen,int adrs,int len,char *bytes);
  int InitStatus;
  Bus *bus;
  int LockNum;
  char *devfile;
  int f;
};

void *LinuxTWIInit(LinuxTWI *,char *devfile);
void LinuxTWIFini(LinuxTWI *);
int LinuxTWILock(LinuxTWI *twi,unsigned num,int flags);
int LinuxTWIUnlock(LinuxTWI *twi,unsigned num,int flags);
int LinuxTWIPreempt(LinuxTWI *twi);
int LinuxTWIWrite(LinuxTWI *,int devadr,int adrslen,int adrs,int len,char *bytes);
int LinuxTWIRead(LinuxTWI *,int devadr,int adrslen,int adrs,int len,char *bytes);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
