#ifndef __PhysicalDIO_H
#define __PhysicalDIO_H
#include "DIO.h"
#include "Bus.h"
#include "DIORaw.h"
#include "Pin.h"

typedef struct PhysicalDIO PhysicalDIO;

struct PhysicalDIO {
  void *FUNC(Init)(void *me);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  void FUNC(Refresh)(void *me);
  void FUNC(Commit)(void *me,int forceall);
  void FUNC(Set)(void *me,int DIONum,DIOState State);
  DIOState FUNC(Get)(void *me,int DIONum);
  void FUNC(SetAsync)(void *me,int DIONum,DIOState State);
  DIOState FUNC(GetAsync)(void *me,int DIONum);
  int FUNC(Wait)(void *me,int *match,int min,int max,int nh,int *h,int nl,int *l);
  unsigned FUNC(Count)(void *me);
  DIOCaps FUNC(Capabilities)(void *me,unsigned num);
  //void FUNC(ToggleAsync)(void *me,int DIONum);
  //void FUNC(Toggle)(void *me,int DIONum);
  int InitStatus;
  unsigned NumLocks;
  Bus *bus;
  DIORaw *dio;
  int gotHUP;
  unsigned char *Caps; // length = NumLocks
};

void *PhysicalDIOInit(PhysicalDIO *,void *bus,void *dio);
void PhysicalDIOFini(PhysicalDIO *);
int PhysicalDIOLock(PhysicalDIO *dio,unsigned num,int flags);
int PhysicalDIOUnlock(PhysicalDIO *dio,unsigned num,int flags);
void PhysicalDIOPreempt(PhysicalDIO *dio);
void PhysicalDIORefresh(PhysicalDIO *);
void PhysicalDIOCommit(PhysicalDIO *,int forceall);
void PhysicalDIOSet(PhysicalDIO *,int DIONum,DIOState State);
DIOState PhysicalDIOGet(PhysicalDIO *,int DIONum);
void PhysicalDIOSetAsync(PhysicalDIO *,int DIONum,DIOState State);
DIOState PhysicalDIOGetAsync(PhysicalDIO *,int DIONum);
int PhysicalDIOWait(PhysicalDIO *,int *match,int min,int max,int nh,
		    int *h,int nl,int *l);
unsigned PhysicalDIOCount(PhysicalDIO *);
DIOCaps PhysicalDIOCapabilities(PhysicalDIO *,unsigned num);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
