#ifndef __SYSTEM_H
#define __SYSTEM_H
#undef FUNC
#ifndef SWIGGY
#define FUNC(x) (*x) 
#else
#define FUNC(x) x
#endif

typedef struct System System;
typedef struct SystemAPI SystemAPI;

typedef struct LockHolderInfo {
  int pid;
  int count;
} LockHolderInfo;

typedef struct ConnectionWaitInfo {
  int pid;
  int wait; // lock waited for, or -1 if none
} ConnectionWaitInfo;

struct BuildInfo {
  unsigned buildNumber;
  int buildTime;
  unsigned uptime;
  char hostname[256], arch[256];
};

struct SystemAPI {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(ClassCount)(void *me);
  int FUNC(InstanceCount)(void *me,int);
  int FUNC(APICount)(void *me,int);
  int FUNC(LockCount)(void *me);
  int FUNC(LockHolderInfo)(void *me,LockHolderInfo *);
  int FUNC(ConnWaitInfo)(void *me,int max,ConnectionWaitInfo *info);
  int FUNC(CANBusGet)(void *me,int);
  void FUNC(BuildInfo)(void *me,struct BuildInfo *);
  int FUNC(ModelId)(void *me);
  int FUNC(BaseBoardId)(void *me);
  int FUNC(MapLength)(void *me);
  int FUNC(MapGet)(void *me,int,char *,int *);
  int FUNC(MapLookup)(void *me,char *);
  int FUNC(MapLookupPartial)(void *me,char *,int,char *);
  int FUNC(MapAdd)(void *me,char *,int);
  int FUNC(MapDelete)(void *me,char *);
};

struct System {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(ClassCount)(void *me);
  int FUNC(InstanceCount)(void *me,int);
  int FUNC(APICount)(void *me,int);
  int FUNC(LockCount)(void *me);
  int FUNC(LockHolderInfo)(void *me,LockHolderInfo *);
  int FUNC(ConnWaitInfo)(void *me,int max,ConnectionWaitInfo *info);
  int FUNC(CANBusGet)(void *me,int);
  void FUNC(BuildInfo)(void *me,struct BuildInfo *);
  int FUNC(ModelId)(void *me);
  int FUNC(BaseBoardId)(void *me);
  int FUNC(MapLength)(void *me);
  int FUNC(MapGet)(void *me,int,char *,int *);
  int FUNC(MapLookup)(void *me,char *);
  int FUNC(MapLookupPartial)(void *me,char *,int,char *);
  int FUNC(MapAdd)(void *me,char *,int);
  int FUNC(MapDelete)(void *me,char *);
  int InitStatus;
};

enum {
  NetSystem_ClassCount=0,
  NetSystem_InstanceCount=1,
  NetSystem_APICount=2,
  NetSystem_LockCount=3,
  NetSystem_LockHolderInfo=4,
  NetSystem_ConnWaitInfo=5,
  NetSystem_CANBusGet=6,
  NetSystem_BuildInfo=7,
  NetSystem_ModelId=8,
  NetSystem_BaseBoardId=9,
  NetSystem_MapLength=10,
  NetSystem_MapGet=11,
  NetSystem_MapLookup=12,
  NetSystem_MapLookupPartial=13,
  NetSystem_MapAdd=14,
  NetSystem_MapDelete=15
};
#define System_APICount (1+NetSystem_MapDelete)
#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
