#ifndef __TSMuxBus_h
#define __TSMuxBus_h
#include "Bus.h"

typedef struct TSMuxBus TSMuxBus;

struct TSMuxBus {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  unsigned char FUNC(Peek8)(void *me,int adrs);
  void FUNC(Poke8)(void *me,int adrs,unsigned char val);
  unsigned short FUNC(Peek16)(void *me,int adrs);
  void FUNC(Poke16)(void *me,int adrs,unsigned short val);
  unsigned FUNC(Peek32)(void *me,int adrs);
  void FUNC(Poke32)(void *me,int adrs,unsigned val);
  int FUNC(BitGet8)(void *me,int adrs,int bit);
  void FUNC(BitAssign8)(void *me,int adrs,int bit,int val);
  void FUNC(BitSet8)(void *me,int adrs,int bit);
  void FUNC(BitClear8)(void *me,int adrs,int bit);
  int FUNC(BitGet16)(void *me,int adrs,int bit);
  void FUNC(BitAssign16)(void *me,int adrs,int bit,int val);
  void FUNC(BitSet16)(void *me,int adrs,int bit);
  void FUNC(BitClear16)(void *me,int adrs,int bit);
  int FUNC(BitGet32)(void *me,int adrs,int bit);
  void FUNC(BitAssign32)(void *me,int adrs,int bit,int val);
  void FUNC(BitSet32)(void *me,int adrs,int bit);
  void FUNC(BitClear32)(void *me,int adrs,int bit);
  void FUNC(PeekStream)(void *me,int adr,int dir,char *buf,int len);
  void FUNC(PokeStream)(void *me,int adr,int dir,char *buf,int len);
  void FUNC(Refresh)(void *me);
  void FUNC(Commit)(void *me,int forceall);
  int FUNC(BitToggle8)(void *me,int adrs,int bit);
  int FUNC(BitToggle16)(void *me,int adrs,int bit);
  int FUNC(BitToggle32)(void *me,int adrs,int bit);
  unsigned char FUNC(Assign8X)(void *me,int adrs,int bit1,int bit0,int val);
  unsigned short FUNC(Assign16X)(void *me,int adrs,int bit1,int bit0,int val);
  unsigned FUNC(Assign32X)(void *me,int adrs,int bit1,int bit0,int val);
  unsigned char FUNC(BitsGet8)(void *me,int adrs,int bit1,int bit0);
  unsigned short FUNC(BitsGet16)(void *me,int adrs,int bit1,int bit0);
  unsigned FUNC(BitsGet32)(void *me,int adrs,int bit1,int bit0);
  int InitStatus;
  unsigned LockBase;
  int deferlockW,deferlockR;
  Bus *configbus, *regbus8, *regbus16;
  int cadrs,base8,base16;
};

void *TSMuxBusInit(TSMuxBus *,void *configbus,int cadrs,void *regbus8, int base8, void *regbus16, int base16);
void TSMuxBusFini(TSMuxBus *);
unsigned char TSMuxBusPeek8(TSMuxBus *,int adrs);
void TSMuxBusPoke8(TSMuxBus *,int adrs,unsigned char val);
unsigned short TSMuxBusPeek16(TSMuxBus *,int adrs);
void TSMuxBusPoke16(TSMuxBus *,int adrs,unsigned short val);
unsigned TSMuxBusPeek32(TSMuxBus *,int adrs);
void TSMuxBusPoke32(TSMuxBus *,int adrs,unsigned val);
int TSMuxBusBitGet8(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusBitAssign8(TSMuxBus *bus,int adrs,int bit,int val);
void TSMuxBusBitSet8(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusBitClear8(TSMuxBus *bus,int adrs,int bit);
int TSMuxBusBitGet16(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusBitAssign16(TSMuxBus *bus,int adrs,int bit,int val);
void TSMuxBusBitSet16(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusBitClear16(TSMuxBus *bus,int adrs,int bit);
int TSMuxBusBitGet32(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusBitAssign32(TSMuxBus *bus,int adrs,int bit,int val);
void TSMuxBusBitSet32(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusBitClear32(TSMuxBus *bus,int adrs,int bit);
void TSMuxBusPeekStream(TSMuxBus *bus,int adr,int dir,char *buf,int len);
void TSMuxBusPokeStream(TSMuxBus *bus,int adr,int dir,char *buf,int len);
void TSMuxBusRefresh(TSMuxBus *);
void TSMuxBusCommit(TSMuxBus *,int forceall);
int TSMuxBusBitToggle8(TSMuxBus *bus,int adrs,int bit);
int TSMuxBusBitToggle16(TSMuxBus *bus,int adrs,int bit);
int TSMuxBusBitToggle32(TSMuxBus *bus,int adrs,int bit);
unsigned char TSMuxBusAssign8X(TSMuxBus *,int adrs,int bit1,int bit0,int val);
unsigned short TSMuxBusAssign16X(TSMuxBus *,int adrs,int bit1,int bit0,int val);
unsigned TSMuxBusAssign32X(TSMuxBus *,int adrs,int bit1,int bit0,int val);
unsigned char TSMuxBusBitsGet8(TSMuxBus *,int adrs,int bit1,int bit0);
unsigned short TSMuxBusBitsGet16(TSMuxBus *,int adrs,int bit1,int bit0);
unsigned TSMuxBusBitsGet32(TSMuxBus *,int adrs,int bit1,int bit0);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
