#ifndef __WBSPI_H
#define __WBSPI_H
#include "SPI.h"
#include "Bus.h"

typedef struct WBSPI WBSPI;
struct WBSPI {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  // "adrs" parameter indicates which CS to assert
  // if adrs < 0, then -adrs is used, and CS left asserted when done
  // otherwise, CS is de-asserted with last transfer
  int FUNC(Write)(void *me,int adrs,unsigned char *buf,int len);
  int FUNC(Read)(void *me,int adrs,unsigned char *buf,int len);
  int FUNC(ReadWrite)(void *me,int adrs,unsigned char *wbuf,unsigned char *rbuf, int len);
  int FUNC(ClockSet)(void *me,unsigned hz);
  int FUNC(EdgeSet)(void *me,int posedge);
  int InitStatus;
  Bus *bus,*bus8;
  int LockNum;
  int offset;
  void (*ChipSelect)(WBSPI *,unsigned num,int asserted);
};

void *WBSPIInit(WBSPI *,void *bus,void *bus8,int offset,void (*)(WBSPI *,unsigned,int));
void WBSPIFini(WBSPI *);
int WBSPILock(WBSPI *spi,unsigned num,int flags);
int WBSPIUnlock(WBSPI *spi,unsigned num,int flags);
void WBSPIPreempt(WBSPI *spi);
int WBSPIWrite(WBSPI *ob,int adrs,char *buf,int len);
int WBSPIRead(WBSPI *ob,int adrs,char *buf,int len);
int WBSPIReadWrite(WBSPI *ob,int adrs,unsigned char *wbuf,unsigned char *rbuf, int len);
int WBSPIClockSet(WBSPI *ob,unsigned hz);
int WBSPIEdgeSet(WBSPI *ob,int posedge);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
