#ifndef __WBWindowBus_h
#define __WBWindowBus_h
#include "Bus.h"

typedef struct WBWindowBus WBWindowBus;

struct WBWindowBus {
  void *FUNC(Init)(void *me,...);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  unsigned char FUNC(Peek8)(void *me,int adrs);
  void FUNC(Poke8)(void *me,int adrs,unsigned char val);
  unsigned short FUNC(Peek16)(void *me,int adrs);
  void FUNC(Poke16)(void *me,int adrs,unsigned short val);
  unsigned FUNC(Peek32)(void *me,int adrs);
  void FUNC(Poke32)(void *me,int adrs,unsigned val);
  int FUNC(BitGet8)(void *me,int adrs,int bit);
  void FUNC(BitAssign8)(void *me,int adrs,int bit,int val);
  void FUNC(BitSet8)(void *me,int adrs,int bit);
  void FUNC(BitClear8)(void *me,int adrs,int bit);
  int FUNC(BitGet16)(void *me,int adrs,int bit);
  void FUNC(BitAssign16)(void *me,int adrs,int bit,int val);
  void FUNC(BitSet16)(void *me,int adrs,int bit);
  void FUNC(BitClear16)(void *me,int adrs,int bit);
  int FUNC(BitGet32)(void *me,int adrs,int bit);
  void FUNC(BitAssign32)(void *me,int adrs,int bit,int val);
  void FUNC(BitSet32)(void *me,int adrs,int bit);
  void FUNC(BitClear32)(void *me,int adrs,int bit);
  void FUNC(PeekStream)(void *me,int adr,int dir,char *buf,int len);
  void FUNC(PokeStream)(void *me,int adr,int dir,char *buf,int len);
  void FUNC(Refresh)(void *me);
  void FUNC(Commit)(void *me,int forceall);
  int FUNC(BitToggle8)(void *me,int adrs,int bit);
  int FUNC(BitToggle16)(void *me,int adrs,int bit);
  int FUNC(BitToggle32)(void *me,int adrs,int bit);
  unsigned char FUNC(Assign8X)(void *me,int adrs,int bit1,int bit0,int val);
  unsigned short FUNC(Assign16X)(void *me,int adrs,int bit1,int bit0,int val);
  unsigned FUNC(Assign32X)(void *me,int adrs,int bit1,int bit0,int val);
  unsigned char FUNC(BitsGet8)(void *me,int adrs,int bit1,int bit0);
  unsigned short FUNC(BitsGet16)(void *me,int adrs,int bit1,int bit0);
  unsigned FUNC(BitsGet32)(void *me,int adrs,int bit1,int bit0);
  int InitStatus;
  unsigned LockBase;
  int deferlock;
  Bus *sub; // bus containing the window registers
  int adrs; // offset address of window
  int offset; // starting offset within the window
};

void *WBWindowBusInit(WBWindowBus *,void *bus,int adrs,int offset);
void WBWindowBusFini(WBWindowBus *);
int WBWindowBusLock(WBWindowBus *bus,unsigned num,int flags);
int WBWindowBusUnlock(WBWindowBus *bus,unsigned num,int flags);
int WBWindowBusPreempt(WBWindowBus *bus);

unsigned char WBWindowBusPeek8(WBWindowBus *,int adrs);
void WBWindowBusPoke8(WBWindowBus *,int adrs,unsigned char val);
unsigned short WBWindowBusPeek16(WBWindowBus *,int adrs);
void WBWindowBusPoke16(WBWindowBus *,int adrs,unsigned short val);
unsigned WBWindowBusPeek32(WBWindowBus *,int adrs);
void WBWindowBusPoke32(WBWindowBus *,int adrs,unsigned val);
int WBWindowBusBitGet8(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusBitAssign8(WBWindowBus *bus,int adrs,int bit,int val);
void WBWindowBusBitSet8(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusBitClear8(WBWindowBus *bus,int adrs,int bit);
int WBWindowBusBitGet16(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusBitAssign16(WBWindowBus *bus,int adrs,int bit,int val);
void WBWindowBusBitSet16(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusBitClear16(WBWindowBus *bus,int adrs,int bit);
int WBWindowBusBitGet32(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusBitAssign32(WBWindowBus *bus,int adrs,int bit,int val);
void WBWindowBusBitSet32(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusBitClear32(WBWindowBus *bus,int adrs,int bit);
void WBWindowBusPeekStream(WBWindowBus *bus,int adr,int dir,char *buf,int len);
void WBWindowBusPokeStream(WBWindowBus *bus,int adr,int dir,char *buf,int len);
void WBWindowBusRefresh(WBWindowBus *);
void WBWindowBusCommit(WBWindowBus *,int forceall);
int WBWindowBusBitToggle8(WBWindowBus *bus,int adrs,int bit);
int WBWindowBusBitToggle16(WBWindowBus *bus,int adrs,int bit);
int WBWindowBusBitToggle32(WBWindowBus *bus,int adrs,int bit);
unsigned char WBWindowBusAssign8X(WBWindowBus *,int adrs,int bit1,int bit0,int val);
unsigned short WBWindowBusAssign16X(WBWindowBus *,int adrs,int bit1,int bit0,int val);
unsigned WBWindowBusAssign32X(WBWindowBus *,int adrs,int bit1,int bit0,int val);
unsigned char WBWindowBusBitsGet8(WBWindowBus *,int adrs,int bit1,int bit0);
unsigned short WBWindowBusBitsGet16(WBWindowBus *,int adrs,int bit1,int bit0);
unsigned WBWindowBusBitsGet32(WBWindowBus *,int adrs,int bit1,int bit0);

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2011, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
